<?php
defined('BASEPATH') OR exit('No direct script access allowed');

//require_once(APPPATH . 'third_party/dompdf/autoload.inc.php');
require_once 'vendor/autoload.php';
use Dompdf\Dompdf;

class Admin extends CI_Controller {

	public function __construct() {
		parent::__construct();
		$this->load->database();
		$this->load->helper('form');
		$this->load->helper('url');
		$this->load->library(array('form_validation', 'session','email'));
		//$autoload['libraries'] = array('database','email','session');

		date_default_timezone_set('Europe/London');

		//load stripe library
		require_once('application/libraries/stripe-php/init.php');

	}

//all of the upcoming appointment list
	public function index()
	{
		$this->login_check();
		$today=date("Y-m-d");

		if(isset($_GET['cust_name']) && isset($_GET['amco_ac_no']) && isset($_GET['postcode']) && isset($_GET['paid_at']))
		{

			$search=false;
			if($_GET['cust_name']!="")
			{
				$this->db->like('cust_name', trim($_GET['cust_name']));
				$search=true;
			}
			if($_GET['amco_ac_no']!="")
			{
				$this->db->like('amco_ac_no', trim($_GET['amco_ac_no']));
				$search=true;
			}
			if($_GET['postcode']!="")
			{
				$this->db->like('postcode', trim($_GET['postcode']));
				$search=true;
			}
			if($_GET['paid_at']!="")
			{
				$this->db->like('paid_at', trim($_GET['paid_at']));
				$search=true;
			}


			if($_GET['paid_at_from']!="" && $_GET['paid_at_to']!="")
			{
				$this->db->where(array('paid_at >='=>trim($_GET['paid_at_from'])));
				$this->db->where(array('paid_at <='=>trim($_GET['paid_at_to'])." 23:59:59"));
			}


			//$this->db->where(array('package_price_id' => null));


			$this->db->order_by('paid_at', 'DESC');

			$app=$this->db->get('payment_data');

		}else{
			$query="SELECT * FROM `payment_data` ORDER BY `paid_at` DESC";
			$app=$this->db->query($query);

		}



		//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount FROM `appointments` WHERE appointment_date > '2023-10-26'  ORDER BY `appointment_date_time`";


		if($app->num_rows()>0)
		{
			$appt_data=$app->result();
			$data=array(
				'payment_data'=>$appt_data,
				'total_appt'=>$app->num_rows(),
			);
		}else{
			$data=array(
				'payment_data'=>null,
				'total_appt'=>0,
			);
		}



		$this->load->view('admin/service_list_all',$data);
	}





//all of the upcoming appointment list
	public function one_time_service()
	{
		$this->login_check();
		$today=date("Y-m-d");

		if(isset($_GET['cust_name']) && isset($_GET['amco_ac_no']) && isset($_GET['postcode']) && isset($_GET['paid_at']))
		{

			$search=false;
			if($_GET['cust_name']!="")
			{
				$this->db->like('cust_name', trim($_GET['cust_name']));
				$search=true;
			}
			if($_GET['amco_ac_no']!="")
			{
				$this->db->like('amco_ac_no', trim($_GET['amco_ac_no']));
				$search=true;
			}
			if($_GET['postcode']!="")
			{
				$this->db->like('postcode', trim($_GET['postcode']));
				$search=true;
			}
			if($_GET['paid_at']!="")
			{
				$this->db->like('paid_at', trim($_GET['paid_at']));
				$search=true;
			}


			if($_GET['paid_at_from']!="" && $_GET['paid_at_to']!="")
			{
				$this->db->where(array('paid_at >='=>trim($_GET['paid_at_from'])));
				$this->db->where(array('paid_at <='=>trim($_GET['paid_at_to'])." 23:59:59"));
			}



			$this->db->where(array('frequency' => 'one-time'));
			$this->db->where(array('subscription_id' => null));
			$this->db->where(array('package_price_id' => null));
			//$this->db->where(array('payment_intent !=' => null));

			$this->db->order_by('paid_at', 'DESC');

			$app=$this->db->get('payment_data');

			//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, payment_intent, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount, service_number, subscription_renewed_on FROM `appointments` WHERE appointment_date = '$search_date' AND subscription_type !='0' ORDER BY `appointment_date_time`";
		}else{

			$query="SELECT * FROM `payment_data` WHERE `frequency` = 'one-time' AND `subscription_id` IS NULL AND `package_price_id` IS NULL ORDER BY `paid_at` DESC";
			$app=$this->db->query($query);

		}



		//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount FROM `appointments` WHERE appointment_date > '2023-10-26'  ORDER BY `appointment_date_time`";

		if($app->num_rows()>0)
		{
			$appt_data=$app->result();
			$data=array(
				'payment_data'=>$appt_data,
				'total_appt'=>$app->num_rows(),
			);
		}else{
			$data=array(
				'payment_data'=>null,
				'total_appt'=>0,
			);
		}



		$this->load->view('admin/one_time_service_list',$data);
	}















	//export data in a pdf f ile
	public function export_data()
	{
		$this->login_check();


		if(isset($_GET['start_date']) && isset($_GET['to_date']) && isset($_GET['format']) && $_GET['start_date']!="" && $_GET['to_date']!="" && $_GET['format']!="")
		{

			$this->db->select('cust_name, email, amco_ac_no, postcode, customer_id, description, service_types, nominal_code, frequency, subscription_id, package_name, subscription_status, subscription_starts, subscription_expiry, payment_intent, amount_to_pay, payment_status, amount_paid, paid_at');

			if($_GET['start_date']!="" && $_GET['to_date']!="")
			{
				$this->db->where(array('paid_at >='=>trim($_GET['start_date'])));
				$this->db->where(array('paid_at <='=>trim($_GET['to_date'])." 23:59:59"));
			}



			/**$this->db->where(array('frequency' => 'one-time'));
			$this->db->where(array('subscription_id' => null));
			$this->db->where(array('package_price_id' => null));**/





			$this->db->order_by('paid_at', 'DESC');

			$app=$this->db->get('payment_data');

			//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, payment_intent, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount, service_number, subscription_renewed_on FROM `appointments` WHERE appointment_date = '$search_date' AND subscription_type !='0' ORDER BY `appointment_date_time`";
		}else{

			header("Location: ".site_url('/one_time_service'));
			die();

		}



		//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount FROM `appointments` WHERE appointment_date > '2023-10-26'  ORDER BY `appointment_date_time`";

		if($app->num_rows()>0)
		{

			if($_GET['format']=="pdf")
			{
				$appt_data=$app->result();
			}else{
				$appt_data=$app->result_array();
			}

			//$appt_data=$app->result();
			$data=array(
				'payment_data'=>$appt_data,
				'total_data'=>$app->num_rows(),
				'start_date'=>trim($_GET['start_date']),
				'to_date'=>trim($_GET['to_date']),
			);

		}else{
			$data=array(
				'payment_data'=>null,
				'total_data'=>0,
				'start_date'=>trim($_GET['start_date']),
				'to_date'=>trim($_GET['to_date']),
			);
		}


		/*$html = $this->load->view('admin/export_pdf',$data, true);
		echo $html;
		die();*/




		if($_GET['format']=="pdf")
		{

			//Generate PDF file
		$dompdf = new Dompdf();


		$html = $this->load->view('admin/export_pdf',$data, true);
		//$html="Hi Mozammel";
		$dompdf->loadHtml($html);
		//$customPaper = array(0,0,1200,2660);
		//$dompdf->setPaper($customPaper);
		$dompdf->setPaper('A3', 'landscape');
		//$dompdf->setPaper('A4', 'portrait');
		$dompdf->render();
		$pdf = $dompdf->output();
		$config['upload_path'] = './exported_files/pdf/';
		// check if folder not exist then create
		if (!is_dir($config['upload_path'])) {
			mkdir($config['upload_path'], 0777,TRUE);
		}
		$path_mlh="AMCO Payment Data (".trim($_GET['start_date'])." To ".trim($_GET['to_date']).") exported at ".date("Y-m-d h-i-sa", time()).".pdf";
		//file_put_contents($config['upload_path'].$path_mlh, $pdf);

			//file_put_contents($file_to_save, $dompdf->output());

//print the pdf file to the screen for saving
			/*header('Content-type: application/pdf');
			header('Content-Disposition: inline; filename="'.$path_mlh.'"');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: ' . filesize($config['upload_path'].$path_mlh));
			header('Accept-Ranges: bytes');
			readfile($config['upload_path'].$path_mlh);*/


			$dompdf->stream($path_mlh, array("Attachment" => true));

		}else{
			$exported_file="AMCO Payment Data (".trim($_GET['start_date'])." To ".trim($_GET['to_date']).") exported at ".date("Y-m-d h-i-sa", time()).".csv";
			//Generate CSV file
			$this->download_send_headers($exported_file);
			echo $this->array2csv($appt_data);
			//header("Location: ".site_url('/admin/one_time_service'));
			die();

		}



		//$this->load->view('admin/one_time_service_list',$data);
	}

private function array2csv(array &$array)
{
	if (count($array) == 0) {
		return null;
	}
	ob_start();
	$df = fopen("php://output", 'w');
	fputcsv($df, array_keys(reset($array)));
	foreach ($array as $row) {
		fputcsv($df, $row);
	}
	fclose($df);
	return ob_get_clean();
}

private function download_send_headers($filename) {
	// disable caching
	$now = gmdate("D, d M Y H:i:s");
	header("Expires: Tue, 03 Jul 2001 06:00:00 GMT");
	header("Cache-Control: max-age=0, no-cache, must-revalidate, proxy-revalidate");
	header("Last-Modified: {$now} GMT");

	// force download
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");

	// disposition / encoding on response body
	header("Content-Disposition: attachment;filename={$filename}");
	header("Content-Transfer-Encoding: binary");
}










//view the Subscription service details
	public function one_time_service_details($db_id=null)
	{
		$this->login_check();


		if($db_id==null)
		{
			header("Location: ".site_url('/admin/one_time_service'));
			die();
		}else{
			$this->db->where('id',$db_id);
			$data=$this->db->get('payment_data');
			if($data->num_rows()>0)
			{
				$appt_data=$data->row();
				/*if($appt_data->subscription_type!="0")
				{
					$this->db->reset_query();
					$this->db->where('appt_id',$appt_data->id);
					$ssd=$this->db->get('service_history');
					if($ssd->num_rows()>0)
					{
						$service_history=$ssd->result();
					}else{
						$service_history=null;
					}
				}else{
					$service_history=null;
				}*/
				$page_data=array('one_time_service'=>$appt_data/*, 'service_history'=>$service_history*/);

				$this->load->view('admin/one_time_service_detail', $page_data);
			}else{
				header("Location: ".site_url('/admin'));
				die();
			}
		}
	}












//subscription customer list
	public function subscription_list()
	{
		$this->login_check();
		$today=date("Y-m-d");

		if(isset($_GET['cust_name']) && isset($_GET['amco_ac_no']) && isset($_GET['postcode']) && isset($_GET['paid_at']))
		{

			$search=false;
			if($_GET['cust_name']!="")
			{
				$this->db->like('cust_name', trim($_GET['cust_name']));
				$search=true;
			}
			if($_GET['amco_ac_no']!="")
			{
				$this->db->like('amco_ac_no', trim($_GET['amco_ac_no']));
				$search=true;
			}
			if($_GET['postcode']!="")
			{
				$this->db->like('postcode', trim($_GET['postcode']));
				$search=true;
			}
			if($_GET['paid_at']!="")
			{
				$this->db->like('paid_at', trim($_GET['paid_at']));
				$search=true;
			}


			if($_GET['paid_at_from']!="" && $_GET['paid_at_to']!="")
			{
				$this->db->where(array('paid_at >='=>trim($_GET['paid_at_from'])));
				$this->db->where(array('paid_at <='=>trim($_GET['paid_at_to'])." 23:59:59"));
			}


			$this->db->where(array('frequency !=' => 'one-time'));
			$this->db->where(array('subscription_id !=' => null));
			$this->db->where(array('package_price_id !=' => null));
			//$this->db->where(array('payment_intent' => null));

			$this->db->order_by('paid_at', 'DESC');

			$app=$this->db->get('payment_data');

			//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, payment_intent, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount, service_number, subscription_renewed_on FROM `appointments` WHERE appointment_date = '$search_date' AND subscription_type !='0' ORDER BY `appointment_date_time`";
		}else{

			$query="SELECT * FROM `payment_data` WHERE `frequency` != 'one-time' AND `subscription_id` IS NOT NULL AND `package_price_id` IS NOT NULL ORDER BY `paid_at` DESC";
			$app=$this->db->query($query);

		}



		//$query="SELECT id, first_name, last_name, email, phone, address, city, state, availability, preferred_arrival_times, total_price, appointment_date_time, appointment_date, appointment_time, appointment_slot, booked_on, payment_status, paid_amount FROM `appointments` WHERE appointment_date > '2023-10-26'  ORDER BY `appointment_date_time`";

		if($app->num_rows()>0)
		{
			$appt_data=$app->result();
			$data=array(
				'payment_data'=>$appt_data,
				'total_appt'=>$app->num_rows(),
			);
		}else{
			$data=array(
				'payment_data'=>null,
				'total_appt'=>0,
			);
		}



		$this->load->view('admin/subscription_service_list',$data);
	}





//view the Subscription service details
	public function subscription_details($db_id=null)
	{
		$this->login_check();


		if($db_id==null)
		{
			header("Location: ".site_url('/admin/subscription_list'));
			die();
		}else{
			$this->db->where('id',$db_id);
			$data=$this->db->get('payment_data');
			if($data->num_rows()>0)
			{
				$appt_data=$data->row();
				/*if($appt_data->subscription_type!="0")
				{
					$this->db->reset_query();
					$this->db->where('appt_id',$appt_data->id);
					$ssd=$this->db->get('service_history');
					if($ssd->num_rows()>0)
					{
						$service_history=$ssd->result();
					}else{
						$service_history=null;
					}
				}else{
					$service_history=null;
				}*/
				$page_data=array('subscription'=>$appt_data/*, 'service_history'=>$service_history*/);

				$this->load->view('admin/subscription_detail', $page_data);
			}else{
				header("Location: ".site_url('/admin'));
				die();
			}
		}
	}









	//create a new subscription in admin portal
	public function add_subscription()
	{
		$this->login_check();


		$data['services']=$this->db->get('service_type')->result();
		$data['packages']=$this->db->get('subscription_packages')->result();


		/*$i=1;
		$package=array();
		foreach ($data['packages'] as $pckg)
		{
			$package[$i]['package_name']=$pckg->package_name;
			$package[$i]['package_name']=$pckg->package_name;
		}*/



		$this->load->view('admin/create_subscription', $data);

	}



	//Create Subscription manually and then send invoice to customer
	public function create_subscription()
	{
		$this->login_check();
		if(isset($_POST['email']) & $_POST['email']!="" && isset($_POST['cust_name']) & $_POST['cust_name']!="")
		{

			$form_data=$_POST;
			/*if(isset($_SESSION['form_data']))
			{
				unset($_SESSION['form_data']);
			}

			$_SESSION['form_data']=$form_data;*/
			$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));




			if(trim($_POST['frequency'])=="one-time" && $_POST['price_id']=="") //single charge payment
			{
//echo "<h2>Not programmed yet.</h2>"; die();

				$this->db->where('customer_email', trim($_POST['email']));
				$cust=$this->db->get('customers');


				if($cust->num_rows()>0)
				{

					$stripe_customer=$cust->row();

					/*echo "<pre>";
					var_dump($stripe_customer);
					echo "</pre>";

					echo "STripe customer id: ".$stripe_customer->stripe_customer_id;*/

					$customer_data=array(
						'id'=>$stripe_customer->id,
						'stripe_customer_id'=>$stripe_customer->stripe_customer_id,
						'customer_email'=>$stripe_customer->customer_email,
						'customer_name'=>$stripe_customer->customer_name,
						'amco_ac_no'=>$stripe_customer->amco_ac_no,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->post_code,
						'description'=>$stripe_customer->description
					);
					$customer_db_id=$stripe_customer->id;
					$stripe_customer_id=$stripe_customer->stripe_customer_id;
					$customer_email=$stripe_customer->customer_email;

				}else{
					//Create customer in stripe
					$stripe_customer=$stripe->customers->create([
						'name' => trim($_POST['cust_name']),
						'email' => trim($_POST['email']),
						'description' => 'Created in Admin Portal',
						'metadata' => [
							'customer_number' => trim($_POST['amco_ac_no']),
							'name' => trim($_POST['cust_name']),
							'postcode' => trim($_POST['postcode'])
						],
					]);


					$customer_data=array(
						'stripe_customer_id'=>$stripe_customer->id,
						'customer_email'=>$stripe_customer->email,
						'customer_name'=>$stripe_customer->name,
						'amco_ac_no'=>$stripe_customer->metadata->customer_number,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->metadata->postcode,
						'description'=>$stripe_customer->description,
						'created_on'=>date("Y-m-d H:i:s",$stripe_customer->created),
					);

					$this->db->insert('customers', $customer_data);

					$customer_db_id=$this->db->insert_id();
					$stripe_customer_id=$stripe_customer->id;
					$customer_email=$stripe_customer->email;
				}




				$invoice=$stripe->invoices->create([
					'customer' => $stripe_customer_id,
					'collection_method' => 'send_invoice',
					'days_until_due' => 15,//==change
					/*'payment_settings'=>
						[
							'payment_method_types'=>'card',
						],*/
				]);



				$invoice_item=$stripe->invoiceItems->create([
					'customer' => $stripe_customer_id,
					'amount' => trim($_POST['amount'])*100,
					'currency' => 'gbp',
					'description' => 'Invoice for AMCO Security',
					'metadata' => [
						'customer_number' => trim($_POST['amco_ac_no']),
						'name' => trim($_POST['cust_name']),
						'postcode' => trim($_POST['postcode'])
					],
					//'price' => trim($_POST['price_id']),
					'invoice' => $invoice->id,
				]);

				$invoice_finalize=$stripe->invoices->finalizeInvoice($invoice->id, []);

				$sendinvoice=$stripe->invoices->sendInvoice($invoice->id, []);






				//Invoice payment url
				$sendinvoice->hosted_invoice_url;
				//pdf-invoice
				$sendinvoice->invoice_pdf;


				$invoice_data=array(
					'invoice_number'=>$invoice_finalize->number,
					'customer_name'=>trim($_POST['cust_name']),
					'amount_due'=>$sendinvoice->amount_due/100,
					'hosted_invoice_url'=>$sendinvoice->hosted_invoice_url,
				);




				$payment_data['email']=$customer_email;
				$payment_data['cust_name']=$form_data['cust_name'];
				$payment_data['postcode']=$form_data['postcode'];
				$payment_data['description']=$form_data['description'];
				$service=explode(":",$form_data['service_types']);
				$payment_data['service_types']=$service[1];
				$payment_data['nominal_code']=$service[0];
				$payment_data['frequency']=$form_data['frequency'];
				$payment_data['payment_intent']=$invoice_finalize->payment_intent;
				//$subscription_data['package_id']=$form_data['package']; //database id of package
				//$subscription_data['package_price_id']=$form_data['price_id']; //stripe price-id
				//$subscription_data['package_name']=$form_data['package_name'];
				$payment_data['amount_to_pay']=$sendinvoice->amount_due/100;//$_SESSION['form_data']['amount'];
				$payment_data['amount_paid']=$sendinvoice->amount_paid/100;
				$payment_data['payment_status']="invoice_sent";
				$payment_data['currency']=$sendinvoice->currency;
				$payment_data['customer_id']=$stripe_customer_id;
				$payment_data['customer_db_id']=$customer_db_id;
				$payment_data['amco_ac_no']=$form_data['amco_ac_no'];
				$payment_data['invoice_id']=$invoice->id;
				$payment_data['created_at']=date("Y-m-d H:i:s", $sendinvoice->created);
				$payment_data['paid_at']=null;



				//insert data to database;
				$this->db->insert('payment_data',$payment_data);


				/**
				Now send an email to Customer here with payment link
				 **/


				if($this->db->insert_id()>0)
				{
					//send email to customer

					$mail_config = Array(
						'mailtype' => 'html',
						'charset' => 'utf-8'
					);

					$this->email->clear(TRUE);
					$this->email->initialize($mail_config);
					$this->email->from($this->config->item('sender_name'), $this->config->item('sender_email'));

					$this->email->to($sendinvoice->customer_email);

					$this->email->subject("Payment Link for Invoice Number: ".$invoice_finalize->number);

					$html_email = $this->load->view('admin/send_single_invoice_email', $invoice_data, true);

					$this->email->message($html_email);
					//echo $html_email;
					//$this->email->send(); //change in server

					if($this->email->send())
					{
						echo "<h4>Invoice has been sent by email.</h4>";
					}else{
						echo "<h3>Invoice couldn't be sent by email.</h3>";
						echo "Stripe Hosted Invoice Payment URL: <br/>".$sendinvoice->hosted_invoice_url;
					}

					echo "<h4>Service synced with Database</h4>";
					//echo "Stripe Hosted Invoice Payment Link: <br/>".$sendinvoice->hosted_invoice_url;


				}else{
					echo "<h3>Service not synced with Database</h3>";
					echo "Stripe Hosted Invoice Payment Link: <br/>".$sendinvoice->hosted_invoice_url;

				}




				echo "<br/><br/><h3><a href='".site_url('admin/add_subscription')."'>Create Another</a></h3><br/><br/>";
				echo "<h3><a href='".site_url('admin/')."'>Go Back To Admin Home</a></h3><br/><br/>";








				/*echo "<h2>Invoice Item:</h2><pre>";
				var_dump($invoice_item);
				echo "</pre>";
				echo "<h2>Invoice Finalize</h2><pre>";
				var_dump($invoice_finalize);
				echo "</pre>";
				echo "<h2>Send Invoice:</h2><pre>";
				var_dump($sendInvoice);
				echo "</pre>";*/







				/**
				die();

				$stripe_customer=$stripe->customers->create([
				'name' => trim($_POST['cust_name']),
				'email' => trim($_POST['email']),
				'description' => 'Created in Admin Portal',
				'metadata' => [
				'customer_number' => trim($_POST['amco_ac_no']),
				'name' => trim($_POST['cust_name']),
				'postcode' => trim($_POST['postcode'])
				],
				]);

				$customer_data=array(
				'customer_id'=>$stripe_customer->id,
				'email'=>$stripe_customer->email,
				'name'=>$stripe_customer->name,
				'customer_number'=>$stripe_customer->metadata->customer_number,
				'customer_name'=>$stripe_customer->metadata->name,
				'customer_postcode'=>$stripe_customer->metadata->postcode,
				'description'=>$stripe_customer->description,
				'created'=>$stripe_customer->created,
				);


				$invoice=$stripe->invoices->create([
				'customer' => $stripe_customer->id,
				'collection_method' => 'send_invoice',
				'days_until_due' => 15,
				]);



				$invoice_item=$stripe->invoiceItems->create([
				'customer' => $stripe_customer->id,
				'price' => trim($_POST['price_id']),
				'invoice' => $invoice->id,
				]);

				$invoice_finalize=$stripe->invoices->finalizeInvoice($invoice->id, []);



				echo "<pre>";
				var_dump($invoice_finalize);
				echo "</pre>";



				echo "<pre>";
				var_dump($invoice_item);
				echo "</pre>";



				echo "<pre>";
				var_dump($invoice);
				echo "</pre>";







				echo "<h3>Stripe Customer Data Array:</h3><br/><pre>";
				var_dump($customer_data);
				echo "</pre><br/>";




				echo "<h3>Stripe Customer Data:</h3><br/><pre>";
				var_dump($stripe_customer);
				echo "</pre><br/>";


				echo "<h3>Form Data:</h3><br/><pre>";
				var_dump($form_data);
				echo "</pre>";

				die();**/




			}else{ //it it's a subscription payment


				$this->db->where('customer_email', trim($_POST['email']));
				$cust=$this->db->get('customers');

				if($cust->num_rows()>0)
				{

					$stripe_customer=$cust->row();

					/*echo "<pre>";
					var_dump($stripe_customer);
					echo "</pre>";

					echo "STripe customer id: ".$stripe_customer->stripe_customer_id;*/

					$customer_data=array(
						'id'=>$stripe_customer->id,
						'stripe_customer_id'=>$stripe_customer->stripe_customer_id,
						'customer_email'=>$stripe_customer->customer_email,
						'customer_name'=>$stripe_customer->customer_name,
						'amco_ac_no'=>$stripe_customer->amco_ac_no,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->post_code,
						'description'=>$stripe_customer->description
					);
					$customer_db_id=$stripe_customer->id;
					$stripe_customer_id=$stripe_customer->stripe_customer_id;
					$customer_email=$stripe_customer->customer_email;

				}else{
					//Create customer in stripe
					$stripe_customer=$stripe->customers->create([
						'name' => trim($_POST['cust_name']),
						'email' => trim($_POST['email']),
						'description' => 'Created in Admin Portal',
						'metadata' => [
							'customer_number' => trim($_POST['amco_ac_no']),
							'name' => trim($_POST['cust_name']),
							'postcode' => trim($_POST['postcode'])
						],
					]);


					$customer_data=array(
						'stripe_customer_id'=>$stripe_customer->id,
						'customer_email'=>$stripe_customer->email,
						'customer_name'=>$stripe_customer->name,
						'amco_ac_no'=>$stripe_customer->metadata->customer_number,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->metadata->postcode,
						'description'=>$stripe_customer->description,
						'created_on'=>date("Y-m-d H:i:s",$stripe_customer->created),
					);

					$this->db->insert('customers', $customer_data);

					$customer_db_id=$this->db->insert_id();
					$stripe_customer_id=$stripe_customer->id;
					$customer_email=$stripe_customer->email;
				}




				//Create Subscription in Stripe
				$subscription=$stripe->subscriptions->create([
					'customer' => $stripe_customer_id,
					'items' => [['price' => trim($_POST['price_id'])]],
					'collection_method' => 'send_invoice',
					'days_until_due' => 15,  //==change //specify the date to pay the invoice for the subscription
					'metadata' => [
						'customer_number' => trim($_POST['amco_ac_no']),
						'name' => trim($_POST['cust_name']),
						'postcode' => trim($_POST['postcode'])
					],
				]);




				//====https://stripe.com/docs/invoicing/integration?method=send-invoice#customize-invoices

				//Generate Send Invoice.
				$sendinvoice=$stripe->invoices->sendInvoice($subscription->latest_invoice, []);



				$invoice_data=array(
					'amount_due'=>$sendinvoice->amount_due/100,
					'amount_paid'=>$sendinvoice->amount_paid/100,
					'amount_remaining'=>$sendinvoice->amount_remaining,
					'billing_reason'=>$sendinvoice->billing_reason,
					'collection_method'=>$sendinvoice->collection_method,
					'created'=>date("Y-m-d H:i:s", $sendinvoice->created),
					'currency'=>$sendinvoice->currency,
					'customer_id'=>$sendinvoice->customer,
					'customer_email'=>$sendinvoice->customer_email,
					'customer_name'=>$sendinvoice->customer_name,
					'default_payment_method'=>$sendinvoice->default_payment_method,
					'hosted_invoice_url'=>$sendinvoice->hosted_invoice_url,
					'invoice_pdf'=>$sendinvoice->invoice_pdf,
					'subscription_description'=>$sendinvoice->lines->data[0]->description,
					'metadata_customer_number'=>$sendinvoice->lines->data[0]->metadata->customer_number,
					'metadata_name'=>$sendinvoice->lines->data[0]->metadata->name,
					'metadata_postcode'=>$sendinvoice->lines->data[0]->metadata->postcode,
					'period_start'=>$sendinvoice->lines->data[0]->period->start,
					'period_end'=>$sendinvoice->lines->data[0]->period->end,
					'invoice_number'=>$sendinvoice->number,
				);

				///handle invoice payment
				/// https://stripe.com/docs/invoicing/integration?method=send-invoice#handle-payment-events


				//Invoice payment url
				$sendinvoice->hosted_invoice_url;
				//pdf-invoice
				$sendinvoice->invoice_pdf;




				$subscription_data['subscription_starts']=date("Y-m-d H:i:s", $subscription->current_period_start);
				$subscription_data['subscription_expiry']=date("Y-m-d H:i:s", $subscription->current_period_end);
				$subscription_data['subscription_status']="unpaid";
				$subscription_data['default_payment_method']=$subscription->default_payment_method;
				$subscription_data['subscription_id']=$subscription->id;
				//$subscription_data['email']=$customer_data->customer_email;
				$subscription_data['email']=$customer_email;

				$subscription_data['cust_name']=$form_data['cust_name'];
				$subscription_data['postcode']=$form_data['postcode'];
				$subscription_data['description']=$form_data['description'];
				$service=explode(":",$form_data['service_types']);
				$subscription_data['service_types']=$service[1];
				$subscription_data['nominal_code']=$service[0];
				$subscription_data['frequency']=$form_data['frequency'];
				$subscription_data['package_id']=$form_data['package']; //database id of package
				$subscription_data['package_price_id']=$form_data['price_id']; //stripe price-id
				$subscription_data['package_name']=$form_data['package_name'];
				$subscription_data['amount_to_pay']=$sendinvoice->amount_due/100;//$_SESSION['form_data']['amount'];
				$subscription_data['amount_paid']=$sendinvoice->amount_paid/100;
				$subscription_data['payment_status']="invoice_sent";
				$subscription_data['currency']=$sendinvoice->currency;
				$subscription_data['customer_id']=$stripe_customer_id;
				$subscription_data['customer_db_id']=$customer_db_id;
				$subscription_data['amco_ac_no']=$form_data['amco_ac_no'];
				$subscription_data['invoice_id']=$sendinvoice->id;
				$subscription_data['created_at']=date("Y-m-d H:i:s", $sendinvoice->created);
				$subscription_data['paid_at']=null;



				//insert data to database;
				$this->db->insert('payment_data',$subscription_data);


				/**
				Now send an email to Customer here with payment link
				 **/


				if($this->db->insert_id()>0)
				{
					//send email to customer

					$mail_config = Array(
						'mailtype' => 'html',
						'charset' => 'utf-8'
					);

					$this->email->clear(TRUE);
					$this->email->initialize($mail_config);
					$this->email->from($this->config->item('sender_name'), $this->config->item('sender_email'));


					$this->email->to($sendinvoice->customer_email);

					$this->email->subject("Payment Link for Invoice Number: ".$sendinvoice->number);

					$html_email = $this->load->view('admin/send_subscription_invoice_email', $invoice_data, true);

					$this->email->message($html_email);
					//echo $html_email;
					//$this->email->send(); //change in server



					if($this->email->send())
					{
						echo "<h4>Invoice has been sent by email.</h4>";
					}else{
						echo "<h3>Invoice couldn't be sent by email.</h3>";
						echo "Stripe Hosted Invoice Payment Link: <br/>".$sendinvoice->hosted_invoice_url;
					}

					echo "<h4>Service synced with Database</h4>";



				}else{
					echo "<h2>Service not synced with Database</h2>";
					echo "Stripe Hosted Invoice Payment Link: <br/>".$sendinvoice->hosted_invoice_url;

				}



				echo "<br/><br/><h3><a href='".site_url('admin/add_subscription')."'>Create Another</a></h3><br/><br/>";
				echo "<h3><a href='".site_url('admin/')."'>Go Back To Admin Home</a></h3><br/><br/>";







				/**
				die();



				echo "<h2>Send Invoice data:</h2><br/><pre>";
				var_dump($sendinvoice);
				echo "</pre>";


				echo "<h2>Subscription data:</h2><br/><pre>";
				var_dump($subscription);
				echo "</pre>";


				die();

				$invoice=$stripe->invoices->create([
				'customer' => $stripe_customer->id,
				'collection_method' => 'send_invoice',
				'subscription' => 'send_invoice',
				'days_until_due' => 30,
				]);



				$invoice_item=$stripe->invoiceItems->create([
				'customer' => $stripe_customer->id,
				'price' => trim($_POST['price_id']),
				'invoice' => $invoice->id,
				]);

				$invoice_finalize=$stripe->invoices->finalizeInvoice($invoice->id, []);



				echo "<pre>";
				var_dump($invoice_finalize);
				echo "</pre>";



				echo "<pre>";
				var_dump($invoice_item);
				echo "</pre>";



				echo "<pre>";
				var_dump($invoice);
				echo "</pre>";







				echo "<h3>Stripe Customer Data Array:</h3><br/><pre>";
				var_dump($customer_data);
				echo "</pre><br/>";




				echo "<h3>Stripe Customer Data:</h3><br/><pre>";
				var_dump($stripe_customer);
				echo "</pre><br/>";


				echo "<h3>Form Data:</h3><br/><pre>";
				var_dump($form_data);
				echo "</pre>";

				die();**/





			}



		}else{
			header("Location: ".site_url('Payment'));
			die();
		}


	}





	/*public function upcoming()
	{
		$this->login_check();
		$this->load->view('admin/upcoming_appt_list');
	}*/





	public function administration()
	{


		$this->login_check("owner");
		$today=date("Y-m-d");


			$query="SELECT * FROM `admin`";
			$app=$this->db->query($query);


		if($app->num_rows()>0)
		{
			$appt_data=$app->result();
			$data=array(
				'admin_data'=>$appt_data,
				'total_admin'=>$app->num_rows(),
			);
		}else{
			$data=array(
				'admin_data'=>null,
				'total_admin'=>0,
			);
		}



		$this->load->view('admin/admin_list',$data);


	}

	//add/create and admin
	public function add_an_admin()
	{
		$this->login_check("owner");
		if(isset($_POST['username']) && isset($_POST['email']) && isset($_POST['name']) && isset($_POST['phone']) && isset($_POST['password']))
		{
			$new_admin=array(
				'username'=>trim($_POST['username']),
				'email'=>trim($_POST['email']),
				'name'=>trim($_POST['name']),
				'phone'=>trim($_POST['phone']),
				'user_level'=>trim($_POST['user_level']),
				'password'=>sha1(trim($_POST['password'])),
			);
			$this->db->insert('admin', $new_admin);
			if($this->db->insert_id()>0)
			{
				header("Location: ".site_url('/admin/administration')."?added=success");
				die();
			}

		}else{
			header("Location: ".site_url('/admin/administration')."?added=failed");
			die();
		}

	}

	//Delete/remove an admin
	public function remove_admin($id=null)
	{
		$this->login_check("owner");

		if($id!=null)
		{
			$this->db->where('id',$id);
			$this->db->delete('admin');
			header("Location: ".site_url('/admin/administration')."?remove=success");
			die();
		}else{
			header("Location: ".site_url('/admin/administration')."?remove=failed");
			die();
		}



	}







//check if the user logged in or not, if not logged in, then redirect to login page
	public function login_check($user_level="admin")
	{
		if(isset($_SESSION['admin_login']) && $_SESSION['admin_login']=="logged_in" && isset($_SESSION['user_level']) && $_SESSION['user_level']!="")
		{
			if($user_level=="owner" && $_SESSION['user_level']!="owner")
			{
				//redirect the admin to home-page if he is not a owner
				header("Location: ".site_url('/admin'));
			}

		}else{
			header("Location: ".site_url('/admin/login'));
			die();
		}
	}



	public function login()
	{
		$error="";
		if(isset($_POST['admin_username']) && $_POST['admin_username']!="" && isset($_POST['admin_password']) && $_POST['admin_password']!="")
		{
			$username=trim($_POST['admin_username']);
			$password=trim($_POST['admin_password']);

			$this->db->where('username', $username);
			$this->db->where('password', sha1($password));
			$admin_d=$this->db->get('admin');

			if($admin_d->num_rows()>0)
			{
				//go ahead to login
				$admin_data=$admin_d->row();

				$admin_info=array(
					'username'=>$admin_data->username,
					'email'=>$admin_data->email,
					'user_level'=>$admin_data->user_level,
					'admin_id'=>$admin_data->id,
					'admin_login'=>'logged_in',
				);

				$this->session->set_userdata('admin_login_data', $admin_info);
				$this->session->set_userdata('admin_login', "logged_in");
				$this->session->set_userdata('user_level', $admin_data->user_level);
				header("Location: ".site_url('/admin'));
				die();

			}else{
				$error="Invalid username or password entered!<br/>Please try again.";
			}

		}/*else{
			header("Location: ".site_url('/admin'));
			die();
		}*/

		if(isset($_SESSION['admin_login']) && $_SESSION['admin_login']=="logged_in")
		{
			header("Location: ".site_url('/admin'));
			die();
		}else{
			$this->load->view('admin/login', array('error'=>$error));
		}

	}




	public function logout()
	{
		if(isset($_SESSION['admin_login']) && $_SESSION['admin_login']="logged_in")
		{
			unset($_SESSION['admin_login_data']);
			unset($_SESSION['admin_login']);
			unset($_SESSION['user_level']);
		}

		header("Location: ".site_url('/admin/login'));
		die();

	}





	//send test email
	public function send_email()
	{
		//$this->load->library('email');


		$mail_config = Array(
			'mailtype' => 'html',
			'charset' => 'utf-8'
		);

		$this->email->clear(TRUE);
		$this->email->initialize($mail_config);


		$this->email->from($this->config->item('sender_name'), $this->config->item('sender_email'));


		$this->email->to("mozammeliu@gmail.com");

		$this->email->subject("Payment Link for Invoice Number: ".date("Y-m-d H:i:s"));

		$html_email = $this->load->view('admin/test_email', array('customer_name'=>'Mozammel Haque', 'amount_due'=>76, 'invoice_number'=>'#ABCD-0039'), true);

		$this->email->message($html_email);
		//echo $html_email;
		//$this->email->send(); //change in server



		if($this->email->send())
		{
			echo "<h1>Invoice has been sent by email.</h1>";
		}else{
			echo "<h1>Invoice couldn't be sent by email.</h1>";
		}

		echo "<h2>Service synced with Database</h2>";
		echo "Stripe Hosted Invoice Payment Link: <br/>";
	}




	//Webhook to sync invoice payment data
	public function webhook()
	{

# This is your Stripe CLI webhook secret for testing your endpoint locally.
$endpoint_secret = 'whsec_a402d046258b545517eb6158950adeb44e71cf7ecf143fd5e299cf06919a13df';
$endpoint_secret = 'whsec_q89RL6At179AO0isOVRNfSLlj1fMmY7H';//new

		//invoice.paid
		//invoice.payment_succeeded


		$endpoint_secret = 'whsec_q89RL6At179AO0isOVRNfSLlj1fMmY7H';//Test Mode

		$payload = @file_get_contents('php://input');
		$sig_header = $_SERVER['HTTP_STRIPE_SIGNATURE'];
		$event = null;

		try {
			$event = \Stripe\Webhook::constructEvent(
				$payload, $sig_header, $endpoint_secret
			);
		} catch(\UnexpectedValueException $e) {
			// Invalid payload
			http_response_code(400);
			exit();
		} catch(\Stripe\Exception\SignatureVerificationException $e) {
			// Invalid signature
			http_response_code(400);
			exit();
		}


		$charge=null;
		$subscription=null;
		$invoice=null;


// Handle the event
		switch ($event->type) {
			case 'invoice.paid'://
				$invoice = $event->data->object;
				$this->webhook_invoice_paid($invoice);
				break;
			case 'invoice.payment_succeeded'://
				$invoice = $event->data->object;
				$this->webhook_invoice_payment_succeeded($invoice);//function fixed for this app
				break;
			default:
				echo 'Received unknown event type ' . $event->type;
		}


		$subscription2 = json_encode($subscription);
		$charge2 = json_encode($charge);
		$invoice2 = json_encode($invoice);

		date_default_timezone_set ('GMT');

		//$this->db->insert('webhook', array('time'=>date('Y-m-d H:i:s', time()),'subscription'=>$subscription2, 'charge'=>$charge2, 'invoice'=>$invoice2));



		http_response_code(200);



	}




	private function webhook_invoice_paid($invoice)
	{


		if($invoice->collection_method=="send_invoice")
		{
			$search['customer_id']=$invoice->customer;
			$search['email']=$invoice->customer_email;
			$search['payment_status']='invoice_sent';

			$search['invoice_id']=$invoice->id;
			$search['subscription_id']=$invoice->subscription;
			//$search['customer_name']=$invoice->customer_name;
			$search['amount_to_pay']=$invoice->amount_paid/100;
			$this->db->where($search);
			$db_data=$this->db->get('payment_data');

			if($db_data->num_rows()>0)
			{
				$new_data=$db_data->row();

				//if it is for a subscription
				if((strlen($invoice->subscription) > 10) && ($invoice->subscription!=null))
				{
					$update_data=array(
						'payment_status'=>$invoice->status,
						'amount_paid'=>$invoice->amount_paid/100,
						'paid_at'=>date('Y-m-d H:i:s', $invoice->webhooks_delivered_at),
						'subscription_status'=>'active',
						'payment_intent'=>$invoice->payment_intent,
					);

				}else{ //if it's for a one-time payment
					$update_data=array(
						'payment_status'=>$invoice->status,
						'amount_paid'=>$invoice->amount_paid/100,
						'paid_at'=>date('Y-m-d H:i:s', $invoice->webhooks_delivered_at),
					);
				}
				//'subscription_status'=>'active',


				$this->db->where('id',$new_data->id);
				$this->db->update('payment_data',$update_data);





				$invoice_email=array(
					'customer_name'=>$invoice->customer_name,
					'email'=>$invoice->customer_email,
					'amount_paid'=>$invoice->amount_paid/100,
					'invoice_number'=>$invoice->number,
				);


				$mail_config = Array(
					'mailtype' => 'html',
					'charset' => 'utf-8'
				);

				$this->email->clear(TRUE);
				$this->email->initialize($mail_config);
				$this->email->from($this->config->item('sender_name'), $this->config->item('sender_email'));


				$this->email->to($invoice->customer_email);

				$this->email->subject("Your Payment of Invoice: ".$invoice->number." Has been paid successfully");

				$html_email = $this->load->view('admin/invoice_paid_email', $invoice_email, true);

				$this->email->message($html_email);
				$this->email->send();


			}

		}




		echo "<pre>";
		var_dump($invoice);
		echo "</pre>";
		die();

	}






	//subscription renewal transaction for successful payment
	private function webhook_invoice_payment_succeeded($invoice)
	{

		var_dump($invoice->lines->data['subscription']);
		var_dump($invoice->lines->data->subscription);
		var_dump($invoice->lines->data);
die();
		//If is it a subscription renewal transaction
		//echo "Customer id: ".$invoice->customer."<br/>";








	}








}
