<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Payment extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/userguide3/general/urls.html
	 */



	public function __construct() {
		parent::__construct();
		$this->load->database();
		$this->load->helper('form');
		$this->load->helper('url');
		$this->load->library(array('form_validation', 'session', 'email'));
		date_default_timezone_set('Europe/London');

		//load stripe library
		require_once('application/libraries/stripe-php/init.php');

	}



	public function index()
	{

		$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));

		/**$checkout_session=$stripe->checkout->sessions->create([
			'success_url' => site_url().'/appointment/save_payment_data?session_id={CHECKOUT_SESSION_ID}',
			'cancel_url' => site_url().'/appointment/failed_payment',
			'line_items' => [[
				'price_data' => [
					'currency' => 'usd',
					'product_data' => [
						'name' => 'Oreclean Living Package',
					],
					'unit_amount' => $_POST['total_price']*100,
				],
				'quantity' => 1,
			]],
			//'customer_creation'=>'always',
			//'payment_method_collection'=>'always',
			'payment_method_types'=>['card','affirm'],
			'currency'=>'USD',
			'customer_email'=>$_POST['email'],
			'mode' => 'payment',
			//'mode' => 'setup',
		]);**/


		//$data['packages']=$this->db->get('subscription_packages')->result();
		$data['services']=$this->db->get('service_type')->result();
		$data['packages']=$this->db->get('subscription_packages')->result();


		/*$i=1;
		$package=array();
		foreach ($data['packages'] as $pckg)
		{
			$package[$i]['package_name']=$pckg->package_name;
			$package[$i]['package_name']=$pckg->package_name;
		}*/



		$this->load->view('customer_info', $data);
	}



	public function get_package_details()
	{
		if(isset($_POST['package']) && isset($_POST['frequency']) )
		{
			$package=trim($_POST['package']);
			$frequency=trim($_POST['frequency']);
			$this->db->where(array('db_id'=>$package));
			$package_info=$this->db->get('subscription_packages')->row();


			if($frequency=="annual")
			{
				$package_price="£".$package_info->annual_price."/Year";
				$price_id=$package_info->annual_price_id;
			}else{
				$package_price="£".$package_info->monthly_price."/Month";
				$price_id=$package_info->monthly_price_id;
			}


			$result=array(
				'package_name'=>$package_info->package_name,
				'package_price'=>$package_price,
				'price_id'=>$price_id,
				'description'=>$package_info->description,
			);


			echo json_encode($result);

		}else{
			return false;
		}
	}





	public function stripe_checkout()
	{

		if(isset($_POST['email']) & $_POST['email']!="" && isset($_POST['cust_name']) & $_POST['cust_name']!="")
		{

			$form_data=$_POST;
			if(isset($_SESSION['form_data']))
			{
				unset($_SESSION['form_data']);
			}
			$_SESSION['form_data']=$form_data;
			$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));




			if(trim($_POST['frequency'])=="one-time" && $_POST['price_id']=="") //single charge payment
			{


				/*post customer*/
				$this->db->where('customer_email', trim($_POST['email']));
				$cust=$this->db->get('customers');

				if($cust->num_rows()>0) {

					$stripe_customer=$cust->row();

					$customer_db_id=$stripe_customer->id;
					$stripe_customer_id=$stripe_customer->stripe_customer_id;
					$customer_email=$stripe_customer->customer_email;

				}else{
					//Create customer in stripe
					$stripe_customer=$stripe->customers->create([
						'name' => trim($_POST['cust_name']),
						'email' => trim($_POST['email']),
						'description' => 'Created in Admin Portal',
						'metadata' => [
							'customer_number' => trim($_POST['amco_ac_no']),
							'name' => trim($_POST['cust_name']),
							'postcode' => trim($_POST['postcode'])
						],
					]);


					$customer_data=array(
						'stripe_customer_id'=>$stripe_customer->id,
						'customer_email'=>$stripe_customer->email,
						'customer_name'=>$stripe_customer->name,
						'amco_ac_no'=>$stripe_customer->metadata->customer_number,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->metadata->postcode,
						'description'=>$stripe_customer->description,
						'created_on'=>date("Y-m-d H:i:s",$stripe_customer->created),
					);

					$this->db->insert('customers', $customer_data);

					$customer_db_id=$this->db->insert_id();
					$stripe_customer_id=$stripe_customer->id;
					$customer_email=$stripe_customer->email;
				}

//customer_db_id
				$_SESSION['form_data']['customer_db_id']=$customer_db_id;
				$_SESSION['form_data']['customer_id']=$stripe_customer_id;



				$checkout_session=$stripe->checkout->sessions->create([
					'success_url' => site_url().'/Payment/save_payment_data?session_id={CHECKOUT_SESSION_ID}',
					'cancel_url' => site_url().'/Payment/failed_payment',
					'line_items' => [[
						'price_data' => [
							'currency' => 'GBP',
							'product_data' => [
								'name' => 'AMCO Security',
							],
							'unit_amount' => trim($_POST['amount'])*100,
						],
						'quantity' => 1,
					]],
					/*'custom_fields' => [
						[
							'key' => 'customer_number',
							'label' => [
								'type' => 'custom',
								'custom' => 'Customer Number',
							],
							'type' => 'text',
						],
					],*/
					'metadata' => [
						'customer_number' => trim($_POST['amco_ac_no']),
						'name' => trim($_POST['cust_name']),
						'postcode' => trim($_POST['postcode'])
					],
					//'customer_creation'=>'always',
					//'payment_method_collection'=>'always',
					'payment_method_types'=>['card'],
					//'currency'=>'USD',
					//'customer_email'=>trim($_POST['email']),
					'customer'=>$stripe_customer_id,
					'mode' => 'payment',
					//'mode' => 'setup',
				]);


			}else{ //it it's a subscription payment



				/*post customer*/
				$this->db->where('customer_email', trim($_POST['email']));
				$cust=$this->db->get('customers');

				if($cust->num_rows()>0) {

					$stripe_customer=$cust->row();

					$customer_db_id=$stripe_customer->id;
					$stripe_customer_id=$stripe_customer->stripe_customer_id;
					$customer_email=$stripe_customer->customer_email;

				}else{
					//Create customer in stripe
					$stripe_customer=$stripe->customers->create([
						'name' => trim($_POST['cust_name']),
						'email' => trim($_POST['email']),
						'description' => 'Created in Admin Portal',
						'metadata' => [
							'customer_number' => trim($_POST['amco_ac_no']),
							'name' => trim($_POST['cust_name']),
							'postcode' => trim($_POST['postcode'])
						],
					]);


					$customer_data=array(
						'stripe_customer_id'=>$stripe_customer->id,
						'customer_email'=>$stripe_customer->email,
						'customer_name'=>$stripe_customer->name,
						'amco_ac_no'=>$stripe_customer->metadata->customer_number,
						//'customer_name'=>$stripe_customer->metadata->name,
						'post_code'=>$stripe_customer->metadata->postcode,
						'description'=>$stripe_customer->description,
						'created_on'=>date("Y-m-d H:i:s",$stripe_customer->created),
					);

					$this->db->insert('customers', $customer_data);

					$customer_db_id=$this->db->insert_id();
					$stripe_customer_id=$stripe_customer->id;
					$customer_email=$stripe_customer->email;
				}

//customer_db_id
				$_SESSION['form_data']['customer_db_id']=$customer_db_id;
				$_SESSION['form_data']['customer_id']=$stripe_customer_id;









				$checkout_session=$stripe->checkout->sessions->create([
					'success_url' => site_url().'/Payment/save_payment_data?session_id={CHECKOUT_SESSION_ID}',
					'cancel_url' => site_url().'/Payment/failed_payment',

					'line_items' => [
						[
							'price' => trim($_POST['price_id']),
							'quantity' => 1,
						],
					],
					/*'custom_fields' => [
						[
							'key' => 'customer_number',
							'label' => [
								'type' => 'custom',
								'custom' => 'Customer Number',
							],
							'type' => 'text',
						],
					],*/
					'metadata' => [
						'customer_number' => trim($_POST['amco_ac_no']),
						'name' => trim($_POST['cust_name']),
						'postcode' => trim($_POST['postcode'])
					],
					//'customer_creation'=>'always',
					'payment_method_collection'=>'always',
					'payment_method_types'=>['card'],
					//'customer_email'=>trim($_POST['email']),
					'customer'=>$stripe_customer_id,
					'mode' => 'subscription',
					//'mode' => 'setup',
				]);


			}

			
			//redirect
			header("HTTP/1.1 303 See Other");
			header("Location: " . $checkout_session->url);


		}else{
			header("Location: ".site_url('Payment'));
			die();
		}
	}




	/*Save payment data for appointment*/
	public function save_payment_data()
	{
		if(isset($_GET['session_id']) && $_GET['session_id']!="" && isset($_SESSION['form_data']))
		{
			$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));
			$stripe_session=$stripe->checkout->sessions->retrieve(
				$_GET['session_id'],
				[]
			);




			//invoice data
			/**$invoice=$stripe->invoices->retrieve($stripe_session->invoice, []);
			$pdf_invoice=$invoice->invoice_pdf;**/



			/*echo $pdf_invoice;
			echo "<pre>";
			var_dump($invoice);
			echo "</pre>";die();*/





			if($stripe_session->mode=="subscription" && $stripe_session->subscription!="")  //if it's a subscription payment
			{

				$subscription_details=$stripe->subscriptions->retrieve($stripe_session->subscription, []);

				$customer_data['subscription_starts']=date("Y-m-d H:i:s", $subscription_details->current_period_start);
				$customer_data['subscription_expiry']=date("Y-m-d H:i:s", $subscription_details->current_period_end);
				$customer_data['subscription_status']="active";
				$customer_data['default_payment_method']=$subscription_details->default_payment_method;


				$customer_data['subscription_id']=$stripe_session->subscription;
				$customer_data['email']=$_SESSION['form_data']['email'];
				$customer_data['cust_name']=$_SESSION['form_data']['cust_name'];
				$customer_data['postcode']=$_SESSION['form_data']['postcode'];
				$customer_data['description']=$_SESSION['form_data']['description'];
				$service=explode(":",$_SESSION['form_data']['service_types']);
				$customer_data['service_types']=$service[1];
				$customer_data['nominal_code']=$service[0];

				$customer_data['frequency']=$_SESSION['form_data']['frequency'];
				$customer_data['package_id']=$_SESSION['form_data']['package']; //database id of package
				$customer_data['package_price_id']=$_SESSION['form_data']['price_id']; //stripe price-id
				$customer_data['package_name']=$_SESSION['form_data']['package_name']; 
				$customer_data['amount_to_pay']=$stripe_session->amount_total/100;//$_SESSION['form_data']['amount'];
				$customer_data['amount_paid']=$stripe_session->amount_subtotal/100;
				//$customer_data['amount_total']=$stripe_session->amount_total/100;
				$customer_data['payment_status']=$stripe_session->payment_status;
				$customer_data['currency']=strtoupper($stripe_session->currency);
				//$customer_data['payment_intent']=$stripe_session->payment_intent;

				$customer_data['customer_id']=$stripe_session->customer;
				$customer_data['customer_db_id']=$_SESSION['form_data']['customer_db_id'];


				$customer_data['paid_at']=date("Y-m-d H:i:s", $stripe_session->created);
				$customer_data['amco_ac_no']=$_SESSION['form_data']['amco_ac_no'];


			}else{   //If it's a single / one-time payment


				//$customer_data['default_payment_method']=$subscription_details->default_payment_method;

				//var_dump($stripe_session);

				//$customer_data['subscription_id']=$stripe_session->subscription;
				$customer_data['email']=$_SESSION['form_data']['email'];
				$customer_data['cust_name']=$_SESSION['form_data']['cust_name'];
				$customer_data['postcode']=$_SESSION['form_data']['postcode'];
				$customer_data['description']=$_SESSION['form_data']['description'];
				$service=explode(":",$_SESSION['form_data']['service_types']);
				$customer_data['service_types']=$service[1];
				$customer_data['nominal_code']=$service[0];

				$customer_data['frequency']=$_SESSION['form_data']['frequency'];
				//$customer_data['package_id']=$_SESSION['form_data']['package']; //database id of package
				//$customer_data['package_price_id']=$_SESSION['form_data']['price_id']; //stripe price-id
				//$customer_data['package_name']=$_SESSION['form_data']['package_name'];
				$customer_data['amount_to_pay']=$stripe_session->amount_total/100;//$_SESSION['form_data']['amount'];
				$customer_data['amount_paid']=$stripe_session->amount_subtotal/100;
				//$customer_data['amount_total']=$stripe_session->amount_total/100;
				$customer_data['payment_status']=$stripe_session->payment_status;
				$customer_data['currency']=strtoupper($stripe_session->currency);

				$customer_data['payment_intent']=$stripe_session->payment_intent;
				//$customer_data['customer_id']=$stripe_session->customer;
				$customer_data['paid_at']=date("Y-m-d H:i:s", $stripe_session->created);
				$customer_data['amco_ac_no']=$_SESSION['form_data']['amco_ac_no'];

				$customer_data['customer_id']=$_SESSION['form_data']['customer_id'];
				$customer_data['customer_db_id']=$_SESSION['form_data']['customer_db_id'];


				/*echo "<pre>";
				var_dump($customer_data);
				echo "</pre>";die();

				die();*/
				
			}






			$this->db->insert('payment_data', $customer_data);
			echo $this->db->insert_id();

			if($this->db->insert_id()>0)
			{
				//echo "Data inserted to DB";


				$msg = <<< HERE
<p>Dear <b>{$customer_data['cust_name']}</b>,</p>
<p>We are pleased to confirm the successful processing of your recent payment for Amount £ {$customer_data['amount_paid']}.</p>
<p>Please see the attached receipt for details of your transaction: [file.pdf]</p>
<p>Should you have any questions our dedicated support team is ready to assist you promptly.</p>
<p>Thank you for choosing AMCO Security. </p>
<p>Best regards,</p>
<p><b>The AMCO Customer Service Team</b></p>
HERE;

				$time_now= date("Y-m-d h:i:sA");
				$subject="AMCO Payment Confirmed Transaction ID £".$_SESSION['payment_data']['amount_paid'];//change
				$headers = "MIME-Version: 1.0" . "\r\n";
				$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
				$headers .= "From: AMCO Security <accounts@amco999.com>\r\n";//change
				$headers .= "Reply-To: AMCO Security <accounts@amco999.com>\r\n";//change
				mail($_SESSION['payment_data']['email'], $subject, $msg, $headers);









				unset($_SESSION['form_data']);
				$_SESSION['payment_data']=$customer_data;


				header("Location: ".site_url('/payment/thankyou'));
				die();

			}else{
				echo "<h2>Failed to save data to Database</h2><h4>Please contact with Server Administrator!</h4>";
			}



		}else{
			header("Location: ".site_url('/payment'));
			die();
		}
	}



	//Success page that shows after successful payment
	public function thankyou()
	{
		if(isset($_SESSION['payment_data']))
		{
			$this->load->view('thankyou', $_SESSION['payment_data']);



			/*date_default_timezone_set("America/New_York");
			$time_now= date("Y-m-d h:i:sA");
			$subject="OreClean Appointment Booking for :";//change
			$headers = "MIME-Version: 1.0" . "\r\n";
			$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
			$headers .= "From: AMCO Security <sales@orecleanliving.com>\r\n";//change
			$headers .= "Reply-To: AMCO Security <sales@orecleanliving.com>\r\n";//change*/




		}else{
			header("Location: ".site_url('/payment'));
			die();
		}
	}
















	public function payment()
	{
		$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));

		$this->load->view('payment_page');
	}



	public function checkout()
	{
		$stripe = new \Stripe\StripeClient($this->config->item('stripe_secret'));




		header('Content-Type: application/json');

		//$YOUR_DOMAIN = 'http://localhost:8888/christopher/public';

		$checkout_session = $stripe->checkout->sessions->create([
			'ui_mode' => 'embedded',
			'payment_method_types' => ['card'],
			'currency'=>'usd',
			'customer_email'=>'mozammeliu@gmail.com',
			'mode' => 'payment',
			'customer_creation' => 'always',
			'line_items' => [[
				'price_data' => [
					'currency' => 'usd',
					'product_data' => [
						'name' => 'AMCO Securities',
					],
					/*'product_data' => [
						'images' => 'AMCO Securities Logo URL Here',
					],*/
					'unit_amount' => 25000,
				],
				'quantity' => 1,
			]],

			//'mode' => 'payment',
			//'success_url' => 'http://localhost:4242/success',
			//'cancel_url' => 'http://localhost:4242/cancel',
			//'return_url' => $YOUR_DOMAIN . '/return.html?session_id={CHECKOUT_SESSION_ID}',
			'return_url' =>site_url() . '/Payment/return?session_id={CHECKOUT_SESSION_ID}',
		]);

		echo json_encode(array('clientSecret' => $checkout_session->client_secret));
	}




}
